#include <glib.h>
#include <glib/gstdio.h>
#include <libsoup/soup.h>

typedef struct _DownloadResourceData {
    gchar *uri;
    gchar *path;
    gboolean overwrite;

    GCancellable *cancellable;
    GCallback callback;
    gpointer user_data;

    GFile *file;
    gchar buffer[16384]; // 16 * 1024
    GOutputStream *output;

    guint64 downloaded_bytes;
    guint64 last_progress_time;
} DownloadResourceData;


void
download_resource_from_uri_async_full (gchar        *uri,
                                       gchar        *path,
                                       gboolean      overwrite,
                                       GCancellable *cancellable,
                                       GCallback     c_handler,
                                       gpointer      user_data);

void
download_resource_from_uri_async (gchar        *uri,
                                  gchar        *path,
                                  gboolean      overwrite,
                                  GCancellable *cancellable);
